/*
 *  Draco Econometrics
 *  Copyright (C) 2009 Approximatrix, LLC
 *  http://www.approximatrix.com
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.approximatrix.draco.application;

import java.util.List;


public interface ChildFrameRegistrar {

	/** Method for opening a new window in this desktop pane
	 * 
	 * @param new_window a valid ChildFrame to add
	 * @return the new window that was passed in
	 */
	public abstract ChildFrame openWindow(ChildFrame new_window);

	/** Returns an array of Objects that the desktop pane contains which
	 * are of the same class as the one specified 
	 * @param value the Class of windows to find and return
	 * @return an array of objects all of the class 'value', or null if none are found
	 * @deprecated newer method should be used
	 */
	public abstract Object[] getWindowsByClass(Class value);

	public abstract <T> List<T> getWindows(Class<T> c);
}