/*
 *  Draco Econometrics
 *  Copyright (C) 2008-2009 Approximatrix, LLC
 *  http://www.approximatrix.com
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.approximatrix.draco.application.plugin;

import java.util.List;
import java.util.Vector;

import javax.script.ScriptContext;
import javax.script.ScriptEngine;
import javax.script.ScriptEngineManager;
import javax.script.ScriptException;

public class PluginRegistry extends Vector<Plugin> {

	private static final String SCRIPT_REGISTRY_BEAN = "registry";
	private static final String SCRIPT_DIRECTORY_BEAN = "directories";
	
	private static final String EXPRESSION_LANG = "ruby";
	private static final String EXPRESSION_SCRIPT = "load '/pengine/register.rb'";
	
	private ScriptEngineManager manager = null;
	
	public PluginRegistry() {
		manager = new ScriptEngineManager();
	}
	
	public void register(List<String> directories) {
		
		ScriptEngine rubyEngine = this.manager.getEngineByName("jruby");
		ScriptContext context = rubyEngine.getContext();
		
		context.setAttribute(SCRIPT_REGISTRY_BEAN, this, ScriptContext.ENGINE_SCOPE);
		context.setAttribute(SCRIPT_DIRECTORY_BEAN, directories, ScriptContext.ENGINE_SCOPE);
		
		try {
			rubyEngine.eval(EXPRESSION_SCRIPT, context);
		} catch(ScriptException be) {
			System.err.println("Error performing plugin registration...");
			be.printStackTrace();
		} 
	}
	
}
