/*
 *  Draco Econometrics
 *  Copyright (C) 2008-2009 Approximatrix, LLC
 *  http://www.approximatrix.com
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.approximatrix.draco.application.worker;

import java.util.EventObject;

import com.approximatrix.draco.fit.LSFit;

public class WorkerEvent extends EventObject {
	
	/** The analysis being performed */
	private LSFit analysis = null;
	
	/** The constructor for a WorkerEvent
	 * 
	 * @param caller the object creating the event
	 * @param message the type of message to deliver
	 */
	public WorkerEvent(Object caller, LSFit analysis) {
		super(caller);
		this.analysis = analysis;
	}
	
	/** Returns the message */
	public LSFit getAnalysis() {
		return this.analysis;
	}
}
