package com.approximatrix.draco.editor.wizard.ui;

import java.awt.Component;
import java.awt.Dimension;
import java.awt.event.KeyAdapter;
import java.awt.event.KeyEvent;

import javax.swing.BoxLayout;
import javax.swing.JLabel;
import javax.swing.JTextField;

import org.pietschy.wizard.InvalidStateException;
import org.pietschy.wizard.PanelWizardStep;

import com.approximatrix.draco.editor.wizard.PluginWizardData;

public class PluginFileFilterStep extends PanelWizardStep {
	
	private PluginWizardData pwd = null;
	
	private JTextField typeTextField = null;
	private JTextField extTextField = null;
	
	public PluginFileFilterStep(PluginWizardData pwd) {
		super("File Filter","Specify the file type and its extension.");
		this.pwd = pwd;
		
		BoxLayout layout = new BoxLayout(this, BoxLayout.Y_AXIS);
		this.setAlignmentX(Component.LEFT_ALIGNMENT);
		this.setLayout(layout);
		
		this.add(new JLabel("File format name:"));
		typeTextField = new JTextField();
		Dimension d = typeTextField.getPreferredSize();
		d.width = 350;
		typeTextField.setMaximumSize(d);
		this.add(typeTextField);
		
		
		this.add(new JLabel("File extension (no period):"));
		extTextField = new JTextField();
		d = extTextField.getPreferredSize();
		d.width = 50;
		extTextField.setMaximumSize(d);
		this.add(extTextField);
		
		KeyTypedAdapter completeListener = new KeyTypedAdapter(typeTextField, extTextField, this);
	}
	
	@Override
	public void applyState() throws InvalidStateException {
		this.pwd.setFileDescription(typeTextField.getText());
		this.pwd.setFileExt(extTextField.getText());
	}
	
	private class KeyTypedAdapter extends KeyAdapter {

		private JTextField one, two;
		private PluginFileFilterStep parent;
		
		public KeyTypedAdapter(JTextField one, JTextField two, PluginFileFilterStep parent) {
			this.one = one;
			this.two = two;
			this.parent = parent;
			
			this.one.addKeyListener(this);
			this.two.addKeyListener(this);
		}
		
		@Override
		public void keyTyped(KeyEvent e) {
			if(!one.getText().isEmpty() && !two.getText().isEmpty())
				this.parent.setComplete(true);
			else
				this.parent.setComplete(false);
		}
		
	}
	
}
