/*
 *  Draco Econometrics
 *  Copyright (C) 2006-2009 Approximatrix, LLC
 *  http://www.approximatrix.com
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.approximatrix.draco.editor.wizard.ui;

import java.awt.BorderLayout;
import java.awt.Dimension;

import javax.swing.JPanel;

import org.pietschy.wizard.PanelWizardStep;

import com.approximatrix.draco.editor.wizard.PluginWizardData;
import com.approximatrix.draco.general.ui.VectorGraphicsPanel;

public class PluginIntroStep extends PanelWizardStep {
	
	private static final String PATH_TO_IMAGE = "/com/approximatrix/draco/application/plugin/ui/images/plugin.svg";
	private PluginWizardData pwd = null;
	
	public PluginIntroStep(PluginWizardData pwd) {
		super("Welcome to the Plugin Wizard","This wizard will guide you through the process of building a Draco plugin.");
		this.pwd = pwd;
		JPanel image_panel = new VectorGraphicsPanel(PATH_TO_IMAGE);
		image_panel.setPreferredSize(new Dimension(250,150));
		this.setLayout(new BorderLayout());
		add(image_panel,BorderLayout.CENTER);
		
		this.setComplete(true);
	}
	
}
