/*
 *  Draco Econometrics
 *  Copyright (C) 2006-2007 Approximatrix, LLC
 *  http://www.approximatrix.com
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.approximatrix.draco.fit.functions;

import org.apache.commons.math.analysis.MultivariateRealFunction;

public interface LikelihoodFunction extends MultivariateRealFunction {

	public abstract double[] initializeParameters();

	public abstract String getLikelihoodType();
	
	public abstract double evaluateLikelihood(double[] parameters);
	
	public abstract double[][] getHessian(double[] parameters);
	
	public abstract double evaluatePDF(double[] parameters, double[] data);
	
	public abstract double evaluateCDF(double[] parameters, double[] data);
	
	public abstract void free();
	
	public abstract void setData(double[][] independent, double[] dependent);
	
	public abstract boolean isReady();
}
