/*
 *  Draco Econometrics
 *  Copyright (C) 2008-2009 Approximatrix, LLC
 *  http://www.approximatrix.com
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.approximatrix.draco.io.sql;

public class DracoSQLTables {

	public static final String VARIABLES = "Variables";
	public static final String VAR_NAME = "name";
	public static final String VAR_DESC = "description";
	public static final String VAR_TYPE = "type";
	public static final String VAR_UNIT = "unit";
	public static final String VAR_BASE = "base";
	public static final String VAR_FORMAT = "format";
	
	public static final String DATA = "Data";
	
	public static final String TEXT = "Text";
	public static final String TEXT_NAME = "name";
	public static final String TEXT_CONTENT = "content";
	public static final String TEXT_EDITABLE = "editable";
	public static final String TEXT_CONTENTTYPE = "type";
	
	public static final String PARAMETERS = "Parameters";
	public static final String PARAM_NAME = "name";
	public static final String PARAM_VALUE = "value";
	public static final String PARAM_OWNER = "owner";
	public static final String PARAM_TYPE = "type";
	
	public static final String ANALYSISDATA = "AnalysisData";
	public static final String AD_OWNER = "owner";
	public static final String AD_VALUE = "value";
	public static final String AD_POSITION = "position";
	public static final String AD_TYPE = "type";
	
	public static final String MATRIXDATA = "MatrixData";
	public static final String MD_OWNER = "owner";
	public static final String MD_VALUE = "value";
	public static final String MD_X = "position_x";
	public static final String MD_Y = "position_y";
	public static final String MD_TYPE = "type";
	
	public static final String PLOTAXISDATA = "PlotAxisData";
	public static final String PAD_OWNER = "owner";
	public static final String PAD_TYPE = "type";
	public static final String PAD_LABEL = "label";
	public static final String PAD_SCALETYPE = "scale_type";
	public static final String PAD_SCALEMODE = "scale_mode";
	public static final String PAD_SCALEMIN = "scale_min";
	public static final String PAD_SCALEMAX = "scale_max";
	public static final String PAD_GRID = "grid";
	
	public static final String PLOTSERIES = "PlotSeries";
	public static final String PS_OWNER = "owner";
	public static final String PS_NAME = "name";
	public static final String PS_XDATA = "x_data";
	public static final String PS_YDATA = "y_data";
	public static final String PS_COLOR = "color";
	public static final String PS_MARKER= "marker";
	public static final String PS_LINE = "line";

	public static final String PLOTDATA = "PlotData";
	public static final String PD_OWNER = "owner";
	public static final String PD_POSITION = "position";
	public static final String PD_VALUE = "value";
	
	public static final String REGRESSION = "Regression";
	public static final String REGR_KEY = "key";
	public static final String REGR_NAME = "name";
	public static final String REGR_TYPE = "type";
	public static final String REGR_RESULTS = "results";
	public static final String REGR_EQUATION = "equation";
	public static final String REGR_SUBTYPE = "subtype";
	
	public static final String REGRESSION_PLUGIN = "RegressionPlugin";
	public static final String REGRPI_REGRESSION = "owner";
	public static final String REGRPI_PLUGIN = "plugin";

    public static final String ANALYSIS_PLUGIN = "AnalysisPlugin";
	public static final String ANPI_ANALYSIS = "owner";
	public static final String ANPI_PLUGIN = "plugin";

    public static final String PLUGIN = "Plugin";
    public static final String PI_KEY = "key";
    public static final String PI_CLASS = "class";
    public static final String PI_NAME = "name";
    public static final String PI_DATA = "data";
    public static final String PI_TYPE = "type";
    public static final String PI_VERSION = "version";
    public static final String PI_ORIGIN = "origin";

	public static final String ANALYSIS = "Analysis";
	public static final String AN_KEY = "key";
	public static final String AN_NAME = "name";
	public static final String AN_TYPE = "type";
	public static final String AN_RESULTS = "results";
	
	public static final String PLOT = "Plot";
	public static final String PLOT_KEY = "key";
	public static final String PLOT_NAME = "name";
	public static final String PLOT_TITLE = "title";
	public static final String PLOT_TYPE = "type";
	
	public static final int TYPE_CONSTANT = 0;
	public static final int TYPE_PARAMETER = 1;
	public static final int TYPE_DEPENDENT = 2;
	public static final int TYPE_INDEPENDENT = 3;
	public static final int TYPE_INSTRUMENT = 4;
	public static final int TYPE_RESIDUAL = 5;
	public static final int TYPE_COVARIANCE = 6;
	public static final int TYPE_ESTIMATE = 7;	

    public static final int TYPE_AXIS_LINEAR = 8;
    public static final int TYPE_AXIS_LOG = 9;
    public static final int TYPE_AXIS_SCALE_MANUAL = 10;
    public static final int TYPE_AXIS_SCALE_AUTO = 11;
    public static final int TYPE_AXIS_X = 12;
    public static final int TYPE_AXIS_Y = 13;
    public static final int TYPE_AXIS_SCALE_NONE = 14;
    
    public static final String TYPE_PLUGIN = "Plugin";
    
    public static final int FLAG_TRUE = 1;
    public static final int FLAG_FALSE = 2;
    
    public static final int PI_TYPE_REGRESSION = 1;
    public static final int PI_TYPE_ANALYSIS = 2;
    
	public static final int OWNER_CONSTANTS = 0;
	public static final int KEY_START_COUNT = 2048;
}

