/*
 *  Draco Econometrics
 *  Copyright (C) 2008-2009 Approximatrix, LLC
 *  http://www.approximatrix.com
 *  
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

package com.approximatrix.draco.main.ui;

import com.approximatrix.draco.application.ChildFrameRegistrar;
import com.approximatrix.draco.datamodel.StatTableModel;

public interface WorksheetHandler extends ChildFrameRegistrar {

	/** Sets the model of the main table to the specified StatTableModel
	 * as long as it is not null.  The routine also fires off some
	 * table updates.
	 * 
	 * @param model the model to become the new table model
	 */
	public abstract void setWindowTableModel(StatTableModel model);

	/** Sets the model of the main table to the specified StatTableModel
	 * as long as it is not null.  The routine also fires off some
	 * table updates.  This version then sets the current_filename value
	 * to the passed String, updating the window title appropriately.
	 * 
	 * @param model the model to become the new table model 
	 * @param filename the filename to set as the current_filename value
	 */
	public abstract void setWindowTableModel(StatTableModel model,
			String filename);

	/** Returns the model of the main table of this window
	 * 
	 * @return the model used by the main table
	 */
	public abstract StatTableModel getWindowTableModel();

	public abstract void setVisibleDesktop(boolean value);
	
	public void setUpdatableTable(boolean value);
	
}