package com.approximatrix.draco.fit.functions;

import static org.junit.Assert.assertTrue;

public abstract class LikelihoodTestSkeleton {

	public abstract void testEvaluatePDF();
	
	public abstract void testEvaluateCDF();
	
	protected void assertWithin(double expected, double actual, double delta) {
		if(delta < 0.0)
			throw new IllegalArgumentException();
		
		assertTrue(expected > actual - delta);
		assertTrue(expected < actual + delta);
	}
}
