package com.approximatrix.draco.math.functions;

import static org.junit.Assert.*;

import org.junit.Test;

public class ErrorFunctionTest {

	private static final double DELTA = 1.0E-4;
	
	private static final double[] VALUE = {
		0.00,
		0.25,
		0.5,
		0.75,
		1.0,
		2.0,
		3.0
	};
	
	private static final double[] ERF = {
		0.0,
		0.2763264,
		0.5204999,
		0.7111556,
		0.8427008,
		0.9953223,
		0.9999779
	};
	
	@Test
	public void testErf() {
		for(int i=0;i<VALUE.length;i++)
			assertCloseTo(ERF[i],ErrorFunction.Erf(VALUE[i]));
	}

	@Test
	public void testErfc() {
		for(int i=0;i<VALUE.length;i++)
			assertCloseTo(1.0-ERF[i],ErrorFunction.Erfc(VALUE[i]));
	}

	@Test
	public void testInvErf() {
		for(int i=0;i<VALUE.length;i++)
			assertCloseTo(VALUE[i],ErrorFunction.InvErf(ERF[i]));
	}
	
	private void assertCloseTo(double expected, double actual) {
		assertTrue(expected+DELTA > actual);
		assertTrue(expected-DELTA < actual);
	}

}
